#ifndef SBCLIB_RESOURCE
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <rnd/streqi.c>
#include <rnd/strconcat.c>
#include <rnd/filedata.c>
#include <shrink.c>

typedef enum {CompressionType_None=0,CompressionType_RLE=1} CompressionType;

char *makearrayname(const char *f)
{ // String constructor
	char *ret; streqi(&ret,f);
	for (int n=0;ret[n];n++) if (!(n?isalnum:isalpha)(ret[n])) ret[n]='_';
	return ret;
}

void make_resource_dat(unsigned char *data,unsigned m,const char *cfileout,const char *arrayname,const CompressionType ct)
{
	int n;
	if (ct==CompressionType_RLE) rle(&data,&m);
	FILE *out=fopen(cfileout,"wt");
	fprintf(out,"unsigned char %s[]={\n\t",arrayname);
	for (n=0;n<m;n++)
	{
		if (n>0) {if (n%16==0) fprintf(out,",\n\t"); else fprintf(out,",");}
		fprintf(out,"%d",data[n]);
	}
	fprintf(out,"};\n");
	fclose(out);
}

void make_resource_ex(const char *datafile,const CompressionType ct,char *cfileout,char *arrayname)
{
	int freec=0,freea=0;
	if (!cfileout) {streqi(&cfileout,datafile); strconcat(&cfileout,".c"); freec=1;}
	if (!arrayname) {arrayname=makearrayname(datafile); freea=1;}
	unsigned m; unsigned char *data=filedata(datafile,&m);
	make_resource_dat(data,m,cfileout,arrayname,ct);
	free(data);
	if (freec) free(cfileout);
	if (freea) free(arrayname);
}

void make_resource(const char *datafile)
{
	make_resource_ex(datafile,CompressionType_None,NULL,NULL);
}

#define unpack_resource(A,F,C) \
{ \
	unsigned m=sizeof(A); unsigned char *tmp=(unsigned char *)malloc(m); \
	memcpy(tmp,A,m); \
	if (C==CompressionType_RLE) unrle(&tmp,&m); \
	FILE *out=fopen(F,"wb"); \
	fwrite(tmp,1,m,out); \
	fclose(out); free(tmp); \
}

#include <rnd/setcwdtohomedir.c>
#define unpack_resource_here(A,F,C) {setcwdtohomedir(); unpack_resource(A,F,C);}

#define SBCLIB_RESOURCE
#endif
